 /*****************************************************************************
 * Copyright (c) 2004 PureChaos, All Rights Reserved.
 * EFZ̃vCdc[(ReplayAssort)
 *
 * Version History
 * Date                Version  Programmer
 * ----------  -------  -------  ------------------------------------------
 * 2004/11/03         0.0.0    R
 *
 ****************************************************************************/

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import java.util.*;
import java.io.*;
import java.net.*;
import org.apache.commons.io.CopyUtils;

public class ReplayAssort extends JFrame{
    private Vector replay = new Vector();
    private Vector orgReplay = new Vector();
    private JScrollPane listScroll = null;
    private JTable      listTable = null;

    private JPanel mainPanel = new JPanel();
    private JPanel listPanel   = new JPanel();
    private JTextField inputFolder  = new JTextField(20);
    private JTextField outputFolder = new JTextField(20);
    private JComboBox p1CharBox = null;
    private JComboBox p1ColorBox = null;
    private JComboBox p2CharBox = null;
    private JComboBox p2ColorBox = null;


    public ReplayAssort(){
        super("ReplayAssort");
        this.setBounds( 30, 0, 100, 200);
        
        Container c = getContentPane();
        mainPanel = new JPanel();
        //mainPanel.setPreferredSize(new Dimension(600, 300));
        mainPanel.setLayout(new GridLayout(1,2,0,0));
        c.add("Center", mainPanel);

        listPanel = new JPanel();
        listPanel.setPreferredSize(new Dimension(300, 400));
        mainPanel.add("Center", listPanel);
        
        JPanel uperPanel   = new JPanel();
        uperPanel.setLayout(new GridLayout(4,1,0,0));
        mainPanel.add("North", uperPanel);
        JPanel inputPanel  = new JPanel();
        JPanel outputPanel = new JPanel();
        //inputPanel.add(inputFolder);
        //outputPanel.add(outputFolder);
        uperPanel.add(inputPanel);
        uperPanel.add(outputPanel);
        
        JButton loadButton = new JButton("tH_烊vCǂݍ");
        JButton copyButton = new JButton("IvCRs[");
        inputPanel.add(loadButton);
        outputPanel.add(copyButton);

        loadButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                loadDialog();

            }
        });

        copyButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                copyDialog();
            }
        });
/************************************************************/
        JPanel maskPanel = new JPanel();
        uperPanel.add(maskPanel);
        
        p1CharBox = new JComboBox();
        p1CharBox.addItem("S");
        p1CharBox.addItem("");
        p1CharBox.addItem("");
        p1CharBox.addItem("");
        p1CharBox.addItem("^");
        p1CharBox.addItem("");
        p1CharBox.addItem("");
        p1CharBox.addItem("");
        p1CharBox.addItem("݂");
        p1CharBox.addItem("x");
        p1CharBox.addItem("S");
        p1CharBox.addItem("");
        p1CharBox.addItem("Y");
        p1CharBox.addItem("hby");
        p1CharBox.addItem("");
        p1CharBox.addItem("薢");
        p1CharBox.addItem("");
        p1CharBox.addItem("Hq");
        p1CharBox.addItem("(N)");
        p1CharBox.addItem("EX݂");
        p1CharBox.addItem("_");
        p1CharBox.addItem("T");
        p1CharBox.addItem("");
        p1CharBox.addItem("ϗ");
        
        p1ColorBox = new JComboBox();
        p1ColorBox.addItem("S");
        p1ColorBox.addItem("1P");
        p1ColorBox.addItem("2P");
        p1ColorBox.addItem("3P");
        p1ColorBox.addItem("4P");
        p1ColorBox.addItem("5P");
        p1ColorBox.addItem("6P");
        
        p2CharBox = new JComboBox();
        p2CharBox.addItem("S");
        p2CharBox.addItem("");
        p2CharBox.addItem("");
        p2CharBox.addItem("");
        p2CharBox.addItem("^");
        p2CharBox.addItem("");
        p2CharBox.addItem("");
        p2CharBox.addItem("");
        p2CharBox.addItem("݂");
        p2CharBox.addItem("x");
        p2CharBox.addItem("S");
        p2CharBox.addItem("");
        p2CharBox.addItem("Y");
        p2CharBox.addItem("hby");
        p2CharBox.addItem("");
        p2CharBox.addItem("薢");
        p2CharBox.addItem("");
        p2CharBox.addItem("Hq");
        p2CharBox.addItem("(N)");
        p2CharBox.addItem("EX݂");
        p2CharBox.addItem("_");
        p2CharBox.addItem("T");
        p2CharBox.addItem("");
        p2CharBox.addItem("ϗ");
            
            
        p2ColorBox = new JComboBox();
        p2ColorBox.addItem("S");
        p2ColorBox.addItem("1P");
        p2ColorBox.addItem("2P");
        p2ColorBox.addItem("3P");
        p2ColorBox.addItem("4P");
        p2ColorBox.addItem("5P");
        p2ColorBox.addItem("6P");
        
        maskPanel.add(p1CharBox);
        maskPanel.add(p1ColorBox);
        maskPanel.add(new JLabel("VS"));
        maskPanel.add(p2CharBox);
        maskPanel.add(p2ColorBox);
        
        JButton maskButton = new JButton("");
        maskPanel.add(maskButton);

        maskButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ReplayProperty.sortType = 0;
                search();
                paintTable();
            }
        });
/************************************************************/
        JPanel sortPanel = new JPanel();
        uperPanel.add(sortPanel);
        
        JButton p1Button = new JButton("1PŃ\[g");
        JButton p2Button = new JButton("2PŃ\[g");
        sortPanel.add(p1Button);
        sortPanel.add(p2Button);

        p1Button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ReplayProperty.sortType = 0;
                sort();
                paintTable();
            }
        });

        p2Button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ReplayProperty.sortType = 1;
                sort();
                paintTable();
            }
        });


        addWindowListener(new WindowAdapter(){
            public void windowClosing(WindowEvent ew){
                System.exit(0);
            }
        });
       
        paintTable();
        this.pack();
        this.setVisible(true); //\
    }



    public void search(){
        String p1Char  = (String)p1CharBox.getSelectedItem();
        String p1Color = (String)p1ColorBox.getSelectedItem();
        String p2Char  = (String)p2CharBox.getSelectedItem();
        String p2Color = (String)p2ColorBox.getSelectedItem();
        replay = new Vector();
            
        for(int i = 0; i < orgReplay.size(); i ++){
            ReplayProperty rp = (ReplayProperty)orgReplay.elementAt(i);

            boolean flag1 = false;
            if( (p1Char.equals("S")  || p1Char.equals(rp.p1Name) ) &&
                (p1Color.equals("S") || p1Color.equals(rp.p1Color+"P") ) &&
                (p2Char.equals("S")  || p2Char.equals(rp.p2Name) )&&
                (p2Color.equals("S") || p2Color.equals(rp.p2Color+"P") ) ){
                flag1 = true;
            }
            
            boolean flag2 = false;
            if( (p1Char.equals("S")  || p1Char.equals(rp.p2Name) ) &&
                (p1Color.equals("S") || p1Color.equals(rp.p2Color+"P") ) &&
                (p2Char.equals("S")  || p2Char.equals(rp.p1Name) ) &&
                (p2Color.equals("S") || p2Color.equals(rp.p1Color+"P") ) ){
                flag2 = true;
            }
            
            if(flag1 || flag2){
                replay.add(rp);
            }
        }
    }

    public void sort(){
        TreeSet tree = new TreeSet();
        for(int i = 0; i < replay.size(); i ++){
            tree.add(replay.elementAt(i));
        }
        
        Vector newReplay = new Vector();
        newReplay.addAll(tree);
        replay = newReplay;
    }


    public void loadDialog(){
        JFileChooser fc = new JFileChooser();
        fc.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        int result = fc.showDialog(this, "ǂݍ");
        if (result == JFileChooser.APPROVE_OPTION) {
            File inputFile = fc.getSelectedFile();
            if(inputFile.exists()){
                orgReplay = new Vector();
                replay = new Vector();
                load(inputFile);
                paintTable();
            }
        }
                
    }
    
    public void load(File base){
        File files[] = base.listFiles();
        for(int i = 0; i < files.length; i ++){
            if(files[i].isDirectory()){
                System.out.println(files[i].getPath() + " ");
                load(files[i]);
            }
            else{
                if(files[i].getName().endsWith(".rep")){
                    ReplayProperty rp = new ReplayProperty();
                    rp.setProperty(files[i]);
                    orgReplay.add(rp);
                    replay.add(rp);
                }
            }
            
        }
    }

    public void copyDialog(){
        JFileChooser fc = new JFileChooser();
        fc.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        int result = fc.showDialog(this, "Rs[");
        if (result == JFileChooser.APPROVE_OPTION) {
            if(listTable != null){
                File outputFile = fc.getSelectedFile();
                outputFile.mkdirs();
                int[] rows = listTable.getSelectedRows();
                int j = 1;
                int k = 1;
                for(int i = 0; i < rows.length; i ++){
                    ReplayProperty rp = (ReplayProperty)replay.elementAt(rows[i]);
                    fileCopy(rp.filePath  +"/"+  rp.fileName ,
                             outputFile.getPath() + "/data" + j + "-" + k + ".rep");
                    k ++;
                    if(k == 10){
                        k = 1;
                        j ++;
                    }
                }
            }
        }
    }


    public void paintTable(){
        listPanel.setLayout(new BorderLayout());
    
        String data[][] = new String[replay.size()][2];
        String columnNames[] = new String[2];
        
        
        columnNames[0] = "vC[P";
        columnNames[1] = "vC[Q";
        for(int i = 0; i < replay.size(); i ++){
            ReplayProperty rp = (ReplayProperty)replay.elementAt(i);
            data[i][0] = rp.p1Name + "(" + rp.p1Color + "P)";
            data[i][1] = rp.p2Name + "(" + rp.p2Color + "P)";
        }
        if(listScroll != null)
            listPanel.remove(listScroll);
        listTable = new JTable((Object[][])data, columnNames);
        listScroll = new JScrollPane(listTable);
        listTable.setPreferredScrollableViewportSize(listPanel.getSize());
        listTable.setVisible(true);
        listPanel.add(listScroll, BorderLayout.CENTER);
        listPanel.doLayout();
    }


    public void fileCopy(String input, String output){
        try{
            FileInputStream in = new FileInputStream(input);
            FileOutputStream out = new FileOutputStream(output);
            CopyUtils.copy(in, out);
            in.close();
            out.close();
        } catch(Exception e){
        }
    }

    //`
    public void paint(Graphics gr){
        super.paint(gr);
    }
    
    public static void main(String[] args){
        

        ReplayAssort ra = new ReplayAssort();

    }
}


class ReplayProperty implements Comparable{
    public String p1Name;
    public int p1Color;
    public String p2Name;
    public int p2Color;
    public String fileName;
    public String filePath;
    public static int sortType = 0;
    
    public void setProperty(File file){
        try{
            FileInputStream input=new FileInputStream(file.getPath());
            byte buf[]=new byte[12];
            input.read(buf);
            input.close();
            p1Name = getCharName(buf[0]);
            p2Name = getCharName(buf[2]);
            p1Color = (int)buf[8]  + 1;
            p2Color = (int)buf[10] + 1;
        }
        catch(Exception e){
        }
        fileName = file.getName();
        filePath = file.getParent();
    }
    
    public String getCharName(byte charIndex){
        String name = "H";
        switch(charIndex){
            case 0:name  = "";break;
            case 1:name  = "";break;
            case 2:name  = "";break;
            case 3:name  = "^";break;
            case 4:name  = "";break;
            case 5:name  = "";break;
            case 6:name  = "";break;
            case 7:name  = "݂";break;
            case 8:name  = "x";break;
            case 9:name  = "S";break;
            case 10:name = ""; break;
            case 11:name = "Y"; break;
            case 12:name = "hby"; break;
            case 13:name = ""; break;
            case 14:name = "薢"; break;
            case 15:name = ""; break;
            case 16:name = "Hq"; break;
            case 17:name = "(N)"; break;
            case 18:name = "EX݂"; break;
            case 19:name = "_"; break;
            case 20:name = "T"; break;
            case 21:name = ""; break;
            case 23:name = "ϗ"; break;
            default:               break;
        }
        return name;
    }
    
   /**
    * IuWFNgr܂B
    * ̊֐equalsƓł͂܂B
    * @param o rΏۂ̃IuWFNg
    * @return r
    */
    public int compareTo(Object o) {
        ReplayProperty rp = (ReplayProperty)o;
        int ans = 1;
        if(sortType == 0){
            ans = (this.p1Name).compareTo(rp.p1Name);
            if(ans == 0){
                ans = this.p1Color - rp.p1Color;
                if(ans == 0){
                    ans = (this.p2Name).compareTo(rp.p2Name);
                    if(ans == 0){
                        ans = this.p2Color - rp.p2Color;
                        if(ans == 0){
                            ans = 1;
                        }
                    }
                    
                }
            }
        }
        else if(sortType == 1){
            ans = (this.p2Name).compareTo(rp.p2Name);
            if(ans == 0){
                ans = this.p2Color - rp.p2Color;
                if(ans == 0){
                    ans = (this.p1Name).compareTo(rp.p1Name);
                    if(ans == 0){
                        ans = this.p1Color - rp.p1Color;
                        if(ans == 0){
                            ans = 1;
                        }
                    }
                    
                }
            }
        }
        
        return ans;
    }
}

/*
0:
1:
2:
3:^
4:
5:
6:
7:݂
8:x
9:S
A:
B:Y
C:hby
D:
E:薢
F:
10:Hq
11:(N)
12:EX݂
13:
14:T
15:
17:ϗ




*/